//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%47F159B9019E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%47F159B9019E.cm

//## begin module%47F159B9019E.cp preserve=no
//## end module%47F159B9019E.cp

//## Module: MathOperator%47F159B9019E; Package body
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/MathOperator.cxx

//## begin module%47F159B9019E.additionalIncludes preserve=no
//## end module%47F159B9019E.additionalIncludes

//## begin module%47F159B9019E.includes preserve=yes
#include <XSUtil/Error/Error.h>
#include <cmath>
//## end module%47F159B9019E.includes

// MathOperator
#include <XSUtil/Numerics/MathOperator.h>
//## begin module%47F159B9019E.declarations preserve=no
//## end module%47F159B9019E.declarations

//## begin module%47F159B9019E.additionalDeclarations preserve=yes
#include <algorithm>
#include <XSUtil/Numerics/Numerics.h>
//## end module%47F159B9019E.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    // Class Numerics::MathOperator 


    //## Other Operations (implementation)
    void MathOperator::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
      //## begin Numerics::MathOperator::operator()%47F242BE0295.body preserve=yes
       throw RedAlert("MathOperator (binary) called with wrong number of arguments.");
      //## end Numerics::MathOperator::operator()%47F242BE0295.body
    }

    void MathOperator::operator () (RealArray& firstAndNew) const
    {
      //## begin Numerics::MathOperator::operator()%47F2435C03B3.body preserve=yes
       throw RedAlert("MathOperator (unary) called with wrong number of arguments.");
      //## end Numerics::MathOperator::operator()%47F2435C03B3.body
    }

    // Additional Declarations
      //## begin Numerics::MathOperator%47F15A0F003B.declarations preserve=yes
      
    // Even though destructor is pure virtual, a definition is still needed.
    // (See item 12.4.7 in the Standard)
    MathOperator::~MathOperator() {}  
      
     
    void PlusOp::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
       firstAndNew += second;
    }
     
    void MinusOp::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
       firstAndNew -= second;
    }
     
    void MultOp::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
       firstAndNew *= second;
    }
     
    void DivideOp::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
       firstAndNew /= second;
    }
     
    void PowOp::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
       firstAndNew = pow(firstAndNew, second);
    }
     
    void MaxOp::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
       Real* pFirst = &firstAndNew[0];
       const size_t sz = firstAndNew.size();
       for (size_t i=0; i<sz; ++i)
       {
          pFirst[i] = std::max(pFirst[i],second[i]);
       }
    }
     
    void MinOp::operator () (RealArray& firstAndNew, const RealArray& second) const
    {
       Real* pFirst = &firstAndNew[0];
       const size_t sz = firstAndNew.size();
       for (size_t i=0; i<sz; ++i)
       {
          pFirst[i] = std::min(pFirst[i],second[i]);
       }       
    }
     
          
     
    void UnaryMinusOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew *= -1.;
    }

    void ExpOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = exp(firstAndNew);
    }
    
    void SinOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = sin(firstAndNew);
    }
    
    void SinDOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew *= DEGTORAD;
       firstAndNew = sin(firstAndNew);
    }
    
    void CosOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = cos(firstAndNew);
    }
    
    void CosDOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew *= DEGTORAD;
       firstAndNew = cos(firstAndNew);
    }
    
    void TanOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = tan(firstAndNew);
    }
    
    void TanDOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew *= DEGTORAD;
       firstAndNew = tan(firstAndNew);
    }
    
    void LogOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = log10(firstAndNew);
    }
    
    void LnOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = log(firstAndNew);
    }
    
    void SqrtOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = sqrt(firstAndNew);
    }
    
    void AbsOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = abs(firstAndNew);
    }
    
    void IntOp::operator () (RealArray& firstAndNew) const
    {
       const size_t sz = firstAndNew.size();
       Real* pVals = &firstAndNew[0];
       for (size_t i=0; i<sz; ++i)
       {
          // deliberate truncation
          int tmp = static_cast<int>(pVals[i]);
          pVals[i] = static_cast<Real>(tmp);
       }
    }
    
    void ASinOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = asin(firstAndNew);
    }
    
    void ACosOp::operator () (RealArray& firstAndNew) const
    {
       firstAndNew = acos(firstAndNew);
    }
    
    void MeanOp::operator () (RealArray& firstAndNew) const
    {
       Real mean = firstAndNew.sum()/firstAndNew.size();
       firstAndNew = mean;
    }
    
    void DimOp::operator () (RealArray& firstAndNew) const
    {
       Real dim = static_cast<Real>(firstAndNew.size());
       firstAndNew = dim;
    }
    
    void SMinOp::operator () (RealArray& firstAndNew) const
    {
       Real smin = firstAndNew.min();
       firstAndNew = smin;
    }
    
    void SMaxOp::operator () (RealArray& firstAndNew) const
    {
       Real smax = firstAndNew.max();
       firstAndNew = smax;
    }
    
      //## end Numerics::MathOperator%47F15A0F003B.declarations

} // namespace Numerics

//## begin module%47F159B9019E.epilog preserve=yes
//## end module%47F159B9019E.epilog
